import sys 
import getpass
s = '/home/'+getpass.getuser()
#s = '/Users/'+getpass.getuser()
sys.path.insert(1, '%s/dptqm/Structural codes/Liouvillian block diagonalization'%s)
sys.path.insert(1, '%s/dptqm/Structural codes/Arnoldi-Linblad time evolution'%s)

from kerr_cavity import * 

def get_cat(N,n,parity='even',phase=0.,):
    alpha = np.sqrt(n)*np.exp(1.j*phase)
    cat = (coherent(N,alpha) + coherent(N,-alpha)) if parity=='even' else (coherent(N,alpha) - coherent(N,-alpha))
    return cat.unit()


class CoupleKerr():
    def __init__(self, c1, c2, chi):
        self.a = tensor(c1.a, qeye(c2.N))
        self.b = tensor(qeye(c1.N), c2.a)
        
        c1ops = [tensor(cop, qeye(c2.N)) for cop in c1.c_ops]
        c2ops = [tensor(qeye(c1.N), cop) for cop in c2.c_ops]
        self.c_ops = c1ops + c2ops
        
        self.χ = chi
        Hint = self.χ * self.a.dag()*self.a*self.b.dag()*self.b
        
        if not(c1.is_timedep):
            if not(c2.is_timedep):
                H0c1 = tensor(c1.H, qeye(c2.N))
                H0c2 = tensor(qeye(c1.N), c2.H)
                self.H = H0c1 + H0c2 + Hint
            else:
                Hc1 = tensor(c1.H, qeye(c2.N))
                H0c2 = tensor(qeye(c1.N), c2.H0)
                H1c2 = tensor(qeye(c1.N), c2.H1)
                self.H = [Hc1+H0c2+Hint, [H1c2, c2.H1_coeff]]
                self.args = c2.args
        else:
            if not(c2.is_timedep):
                Hc2 = tensor(qeye(c1.N), c2.H)
                H0c1 = tensor(c1.H0, qeye(c2.N))
                H1c1 = tensor(c1.H1, qeye(c2.N))
                self.H = [Hc2+H0c1+Hint, [H1c1, c1.H1_coeff]]
                self.args = c1.args
            else:
                H0c2 = tensor(qeye(c1.N), c2.H0)
                H1c2 = tensor(qeye(c1.N), c2.H1)
                H0c1 = tensor(c1.H0, qeye(c2.N))
                H1c1 = tensor(c1.H1, qeye(c2.N))
                
                self.H = [H0c1+H0c2+Hint, [H1c1, c1.H1_coeff], [H1c2, c2.H1_coeff]]
                self.args = [c1.args,c2.args]
                
                
                
                
                
                

                